#include "llvm/Pass.h"
#include "llvm/Function.h"
#include "llvm/Module.h"
#include "llvm/Support/InstIterator.h"
#include "llvm/Support/raw_ostream.h"
#include "llvm/Instructions.h"
#include "llvm/Type.h"

#include <ostream>
#include <fstream>
#include <iostream>

using namespace llvm;
using namespace std;

namespace {

class ArrayReorderingV2 : public ModulePass {

public:

static char ID;

ArrayReorderingV2() : ModulePass(ID) { }

virtual bool runOnFunction(Function &F) {
	cout<<"found function"<<endl;
	for (Function::iterator FI = F.begin(), FE = F.end(); FI != FE; ++FI) {
		BasicBlock* block = FI;
		errs()<<block->getName()<<"\n";
		for (BasicBlock::iterator BI = block->begin(), BE = block->end(); BI != BE; ++BI) {
			Instruction* inst = BI;
			errs()<<*inst<<"\n";
		}
	}
	return false;
}

virtual bool insertInst(Function &F){
	for (Function::iterator FI = F.begin(), FE = F.end(); FI != FE; ++FI) {
		BasicBlock* block = FI;
		for (BasicBlock::iterator BI = block->begin(), BE = block->end(); BI != BE; ++BI) {
			Instruction* inst = BI;
			//AllocaInst* newInst = new AllocaInst(Type::getInt32Ty(BI->getContext()));
			AllocaInst* newInst = new AllocaInst(ArrayType::get(Type::getInt32Ty(BI->getContext()), 5));
			block->getInstList().insert(inst, newInst);
		}
	}
	return false;
}

virtual bool runOnModule(Module& M) {
	for (Module::iterator MI = M.begin(), ME = M.end(); MI != ME; ++MI) {
		runOnFunction(*MI);
		//insertInst(*MI);
		//cout<<"==========="<<endl;
		//runOnFunction(*MI);
	}
	return false;
}

private:
};

char ArrayReorderingV2::ID = 0;
RegisterPass<ArrayReorderingV2> X("cd-ar2",
    "15745 ArrayReorderingV2");

}
