#include<vector>
#include<iostream>
#include<stdlib.h>

using namespace std;

class MatrixSolver{
public: 
	vector<vector<int> > solve(vector<vector<int> > H, int range_begin, int range_end, vector<float> iterations){
		cout<<"printing  H matrix"<<endl;
		printMatrix(H);
		//result matrix: d*m matrix, m = H[0].size();		
		vector<vector<int> > result;
		if(H.size()==0){
			return result;
		}
	    	int m = H[0].size();
		//int r = 1;
		int r = iterations.size();
		int d = m;
		cout<<"d:"<<d<<endl;
		for(int i=0; i<d; i++){			
			vector<vector<int> > solutions = generate_candidate(range_begin, range_end, m);
			cout<<solutions.size()<<endl;
			//printMatrix(solutions);
			int min_index = 1;
			float min_cost = 100000;
			for(int j = 0; j<solutions.size(); j++){
				
				if(notfeasible(solutions[j], result) || allzero(solutions[j]))
					continue;
				//print(solutions[j]);			
				float cost = 0;
				//add all access patterns
				for(int k=0; k<r; k++){
					int sum = add(solutions[j], H[k]);
					if((sum < 0 && i<d-1) || (sum <= 0 && i==d-1)){
					//if(sum == 0 && i==d-1){
						cost = min_cost;
						break;
					}
					else{
						cost += (float)sum*iterations[k];
					}
				}
				
				if(cost<min_cost){
					min_cost = cost;
					cout<<"cost: "<<cost<<endl;
					print(solutions[j]);
					min_index = j;
					print(solutions[j]);
				}
			}
			result.push_back(solutions[min_index]);
		}

	    	return result;
	};

	void printMatrix(vector<vector<int> > matrix){
	    int row = matrix.size();
	    if(row==0)
		return;
	    int col = matrix[0].size();
	    for(int i=0; i<row; i++){
		for(int j=0; j<col; j++){
			cout<<matrix[i][j]<<" ";
		}
		cout<<endl;
	    }
	    return;
	};

private:
	bool allzero(vector<int> vec){
		for(int i=0; i<vec.size(); i++){
			if(vec[i]!=0)
				return false;
		}
		return true;
		
	};

	bool notfeasible(vector<int> vec, vector<vector<int> > result){
		for (int i = 0; i < result.size(); i++)
			if (isSimilar(vec, result[i]))
				return true;
		return false;
	}

	bool isSimilar(vector<int> vec1, vector<int> vec2){
		int sum1 = 0;
		int sum2 = 0;
		for (int i = 0; i < vec1.size(); i++){
			sum1 += abs(vec1[i]-vec2[i]);
			sum2 += abs(vec1[i]+vec2[i]);
		}
		if(sum1==0 || sum2==0)
			return true;
		return false;
	}
	

	int add(vector<int> vec1, vector<int> vec2){
		if(vec1.size()!=vec2.size()){
			return 0;
		}
		int sum = 0;
		for(int i=0; i<vec1.size(); i++){
			sum += vec1[i]*vec2[i];
		}
		return sum;
	};

	vector<vector<int> > generate_candidate(int range_begin, int range_end, int m){
		vector<vector<int> > result;
		if(m==0){
			return result;
		}
		//cout<<m<<endl;
		
		vector<int> list;
		list.push_back(0);
		for(int i=0; i<=range_end; i++){
			list.push_back(i);
			list.push_back(-i);
		}
		for(int j=0; j<list.size(); j++){						
			vector<vector<int> > temp = generate_candidate(range_begin, range_end, m-1);
			//cout<<"printing temp"<<endl;
			//printMatrix(temp);
			if(temp.size()==0){
				vector<int> temp1;
				temp1.push_back(list[j]);
				result.push_back(temp1);
			}
			for(int k=0; k<temp.size(); k++){
				vector<int> temp1;
				temp1.push_back(list[j]);
				for(int s=0; s<temp[k].size(); s++)
					temp1.push_back(temp[k][s]);
				result.push_back(temp1);
			}
		}
		return result;
	};

	void print(vector<int> matrix){
	    int row = matrix.size();
	    if(row==0)
		return;
	    for(int i=0; i<row; i++){
		cout<<matrix[i]<<" ";
	    }
	    cout<<endl;
	    return;
	};

	

	vector<int> solve_last_eq(vector<int> A, int b, vector<int> range){
	    vector<int> result;
	    int range_size = range.size();
	    if(A.size()==1){
		for (int i=0; i<range_size; i++){
		    if(A[0]*range[i]==b){
		        result.push_back(range[i]);
		        break;
		    }
		}
	    }
	    else{
		vector<int> B;
		for(int k=0; k<A.size()-1; k++){
		    B.push_back(A[k]);
		}
		for(int i=0; i<range_size; i++){
		    int temp = b-A[A.size()-1]*range[i];
		    if(temp>=0){
		        vector<int> xsub = solve_last_eq(B, temp, range);
		        if(xsub.size()>0){
		            for(int j=0; j<xsub.size(); j++){
		                result.push_back(xsub[j]);
		            }
		            result.push_back(range[i]);
		            break;
		        }
		    }
		}
	    }
	    return result;
	};

	int gcd(vector<int> vec){
	    int a=vec[0];
	    int b=vec[1];
	    int t;
	    while(b!=0){
		t = b;
		b = a%t;
		a = t;
	    }
	    return a;
	};
};
